#if !defined(__ottstapp_h)              // Sentry, use file only if it's not already included.
#define __ottstapp_h

/*  Project ottest
    Freeman-Teresa Software
    Copyright  1994. All Rights Reserved.

    SUBSYSTEM:    ottest.exe Application
    FILE:         ottstapp.h
    AUTHOR:       Kent Tong


    OVERVIEW
    ========
    Class definition for ottestApp (TApplication).      
*/


#include <owl\owlpch.h>
#pragma hdrstop

#include <owl\statusba.h>
#include <owl\opensave.h>

#include "ottstapp.rh"            // Definition of all resources.


//{{TApplication = ottestApp}}
class ottestApp : public TApplication {
private:
    TWindow *Client;                                 // Client window for the frame.
    TOpenSaveDialog::TData FileData;                    // Data to control open/saveas standard dialog.

public:
    ottestApp ();
    virtual ~ottestApp ();

    void OpenFile (const char *fileName = 0);
//{{ottestAppVIRTUAL_BEGIN}}
public:
    virtual void InitMainWindow();
//{{ottestAppVIRTUAL_END}}

//{{ottestAppRSP_TBL_BEGIN}}
protected:
    void CmFileNew ();
    void CmFileOpen ();
    void CmFileClose ();
    void CmHelpAbout ();
    void CmTest1 ();
    void CmTest2 ();
    void CmTest3 ();
    void CmTest7 ();
    void CmTest8 ();
    void CmTest6 ();
    void CmTest4 ();
    void CmTest5 ();
//{{ottestAppRSP_TBL_END}}
  DECLARE_RESPONSE_TABLE(ottestApp);
};    //{{ottestApp}}


#endif                                      // __ottstapp_h sentry.
